if PlayerDamage.breakLegs then return end

local oldRegenerated = PlayerDamage._regenerated

function PlayerDamage:_regenerated(...)
    oldRegenerated(self, ...)
    
    local brokenLegCount = self._brokenLegCount or 0
    
    if brokenLegCount > 0 then
        managers.hud:youGainBrouzouf("My legs are OK")
        self._brokenLegCount = 0
    end
end

local oldDowned = PlayerDamage.on_downed

function PlayerDamage:on_downed(...)
    oldDowned(self, ...)
    self:breakLegs()
end


function PlayerDamage:breakLegs()
    local brokenLegCount = self._brokenLegCount or 0
    
    if brokenLegCount < 2 then
        managers.hud:youGainBrouzouf("Your leg is broken")
        self._brokenLegCount = brokenLegCount + 1
    end
end


function wrapLegs(oldFunc, breakChanceMult)
    return function(self, ...)
        local healthBefore = self:health_ratio()
        local ret = oldFunc(self, ...)
        local healthAfter = self:health_ratio()
        
        local healthReduction = self._max_health_reduction
        local rand = math.random()
        
        if rand < (((healthBefore - healthAfter) * breakChanceMult) / healthReduction) then
            self:breakLegs()
        end
        
        return ret
    end
end

PlayerDamage.damage_fall      = wrapLegs(PlayerDamage.damage_fall,      2)
PlayerDamage.damage_explosion = wrapLegs(PlayerDamage.damage_explosion, 0.75)
PlayerDamage.damage_bullet    = wrapLegs(PlayerDamage.damage_bullet,    0.25)