if wrapUltraFail then return end

local messageRanges = 
{
    ["Bullshit! Ultra-failed attack!"] = {0,     0.01},
    ["Damn! Failed attack!"]           = {0.01,  0.025},
    ["Good! Critical attack!"]         = {0.975, 0.99},
    ["Perfect attack!"]                = {0.99,  1.001},
}

function wrapUltraFail(oldFunc)
    return function(self, attack_data, ...)
        local ret = oldFunc(self, attack_data, ...)
        if not ret then return end
        
        if not BrouzoufSettings:get("docriticals") then return ret end
    
        local killer = attack_data.attacker_unit
        if killer == nil then return ret end
        local killerBase = killer:base()
        
        -- is actually projectile
        if killerBase._thrower_unit ~= nil then
            local newKiller = killerBase._thrower_unit
            local newBase   = newKiller.base and newKiller:base()
            
            if newBase then
                killer     = newKiller
                killerBase = newBase
            end
        end
    
        local you = managers.player:player_unit()
        if alive(killer) and you ~= killer then return ret end
        
        local rand = math.random()
        
        for msg, chance in pairs(messageRanges) do
            if rand >= chance[1] and rand < chance[2] then
                managers.hud:addCenterText(msg)
            end
        end
        
        return ret
    end
end

CopDamage.damage_bullet     = wrapUltraFail(CopDamage.damage_bullet)
CopDamage.damage_explosion  = wrapUltraFail(CopDamage.damage_explosion)
CopDamage.damage_melee      = wrapUltraFail(CopDamage.damage_melee)