local specialDudes = 
{
    sniper            = 1,
    taser             = 1,
    shield            = 1,
    medic             = 1,
    phalanx_vip       = 1,
    phalanx_minion    = 1,
    heavy_swat_sniper = 1,
}

local beastDudes =
{
    tank              = 1,
    tank_mini         = 1,
    tank_medic        = 1,
    spooc             = 1,
    
    mobster_boss           = 1,
    hector_boss            = 1,
    hector_boss_stealth    = 1,
    biker_boss             = 1,
    chavez_boss            = 1,
    drug_lord_boss         = 1,
    drug_lord_boss_stealth = 1,
}


local function onDeath(unit, damageInfo)
    local unitBase = unit:base()
    if not unitBase then return end
    local unitName = unitBase._tweak_table
    
    -- get killer data
    local killer = damageInfo.attacker_unit
    if killer == nil then return end
    local killerBase = killer:base()
    
    -- is actually projectile
    if killerBase._thrower_unit ~= nil then
        local newKiller = killerBase._thrower_unit
        
        if newKiller and alive(newKiller) then
            local newBase = newKiller.base and newKiller:base()
            
            if newBase then
                killer     = newKiller
                killerBase = newBase
            end
        end
    end
    
    local you = managers.player:player_unit()
    
    if alive(killer) and you == killer then
        managers.hud:youGainBrouzouf()
        
        if BrouzoufSettings:get("doenemykills") then
            local isSpecial = specialDudes[unitName] or 0
            local isBeast   = beastDudes[unitName]   or 0
        
            local specialRoll = math.random()
            
            if isBeast > specialRoll then
                managers.hud:youKilledABeast()
                
            elseif isSpecial > specialRoll then
                managers.hud:youKilledASpecial()
                
            else
                managers.hud:youKilledAGoodAndCaringDaddy()
            end
        end
    end
end

local oldDeath = EnemyManager.on_enemy_died
function EnemyManager:on_enemy_died(dead_unit, damage_info, ...)
    onDeath(dead_unit, damage_info)
    return oldDeath(self, dead_unit, damage_info, ...)
end